package slb

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeAccessControlLists invokes the slb.DescribeAccessControlLists API synchronously
// api document: https://help.aliyun.com/api/slb/describeaccesscontrollists.html
func (client *Client) DescribeAccessControlLists(request *DescribeAccessControlListsRequest) (response *DescribeAccessControlListsResponse, err error) {
	response = CreateDescribeAccessControlListsResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeAccessControlListsWithChan invokes the slb.DescribeAccessControlLists API asynchronously
// api document: https://help.aliyun.com/api/slb/describeaccesscontrollists.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeAccessControlListsWithChan(request *DescribeAccessControlListsRequest) (<-chan *DescribeAccessControlListsResponse, <-chan error) {
	responseChan := make(chan *DescribeAccessControlListsResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeAccessControlLists(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeAccessControlListsWithCallback invokes the slb.DescribeAccessControlLists API asynchronously
// api document: https://help.aliyun.com/api/slb/describeaccesscontrollists.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) DescribeAccessControlListsWithCallback(request *DescribeAccessControlListsRequest, callback func(response *DescribeAccessControlListsResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeAccessControlListsResponse
		var err error
		defer close(result)
		response, err = client.DescribeAccessControlLists(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeAccessControlListsRequest is the request struct for api DescribeAccessControlLists
type DescribeAccessControlListsRequest struct {
	*requests.RpcRequest
	AccessKeyId          string                           `position:"Query" name:"access_key_id"`
	ResourceOwnerId      requests.Integer                 `position:"Query" name:"ResourceOwnerId"`
	AclName              string                           `position:"Query" name:"AclName"`
	AddressIPVersion     string                           `position:"Query" name:"AddressIPVersion"`
	PageNumber           requests.Integer                 `position:"Query" name:"PageNumber"`
	ResourceGroupId      string                           `position:"Query" name:"ResourceGroupId"`
	PageSize             requests.Integer                 `position:"Query" name:"PageSize"`
	Tag                  *[]DescribeAccessControlListsTag `position:"Query" name:"Tag"  type:"Repeated"`
	ResourceOwnerAccount string                           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string                           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer                 `position:"Query" name:"OwnerId"`
	Tags                 string                           `position:"Query" name:"Tags"`
}

// DescribeAccessControlListsTag is a repeated param struct in DescribeAccessControlListsRequest
type DescribeAccessControlListsTag struct {
	Value string `name:"Value"`
	Key   string `name:"Key"`
}

// DescribeAccessControlListsResponse is the response struct for api DescribeAccessControlLists
type DescribeAccessControlListsResponse struct {
	*responses.BaseResponse
	RequestId  string `json:"RequestId" xml:"RequestId"`
	TotalCount int    `json:"TotalCount" xml:"TotalCount"`
	PageSize   int    `json:"PageSize" xml:"PageSize"`
	Count      int    `json:"Count" xml:"Count"`
	PageNumber int    `json:"PageNumber" xml:"PageNumber"`
	Acls       Acls   `json:"Acls" xml:"Acls"`
}

// CreateDescribeAccessControlListsRequest creates a request to invoke DescribeAccessControlLists API
func CreateDescribeAccessControlListsRequest() (request *DescribeAccessControlListsRequest) {
	request = &DescribeAccessControlListsRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Slb", "2014-05-15", "DescribeAccessControlLists", "slb", "openAPI")
	return
}

// CreateDescribeAccessControlListsResponse creates a response to parse from DescribeAccessControlLists response
func CreateDescribeAccessControlListsResponse() (response *DescribeAccessControlListsResponse) {
	response = &DescribeAccessControlListsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
