package slb

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// SetVServerGroupAttribute invokes the slb.SetVServerGroupAttribute API synchronously
// api document: https://help.aliyun.com/api/slb/setvservergroupattribute.html
func (client *Client) SetVServerGroupAttribute(request *SetVServerGroupAttributeRequest) (response *SetVServerGroupAttributeResponse, err error) {
	response = CreateSetVServerGroupAttributeResponse()
	err = client.DoAction(request, response)
	return
}

// SetVServerGroupAttributeWithChan invokes the slb.SetVServerGroupAttribute API asynchronously
// api document: https://help.aliyun.com/api/slb/setvservergroupattribute.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) SetVServerGroupAttributeWithChan(request *SetVServerGroupAttributeRequest) (<-chan *SetVServerGroupAttributeResponse, <-chan error) {
	responseChan := make(chan *SetVServerGroupAttributeResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.SetVServerGroupAttribute(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// SetVServerGroupAttributeWithCallback invokes the slb.SetVServerGroupAttribute API asynchronously
// api document: https://help.aliyun.com/api/slb/setvservergroupattribute.html
// asynchronous document: https://help.aliyun.com/document_detail/66220.html
func (client *Client) SetVServerGroupAttributeWithCallback(request *SetVServerGroupAttributeRequest, callback func(response *SetVServerGroupAttributeResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *SetVServerGroupAttributeResponse
		var err error
		defer close(result)
		response, err = client.SetVServerGroupAttribute(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// SetVServerGroupAttributeRequest is the request struct for api SetVServerGroupAttribute
type SetVServerGroupAttributeRequest struct {
	*requests.RpcRequest
	AccessKeyId          string           `position:"Query" name:"access_key_id"`
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	BackendServers       string           `position:"Query" name:"BackendServers"`
	VServerGroupId       string           `position:"Query" name:"VServerGroupId"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	Tags                 string           `position:"Query" name:"Tags"`
	VServerGroupName     string           `position:"Query" name:"VServerGroupName"`
}

// SetVServerGroupAttributeResponse is the response struct for api SetVServerGroupAttribute
type SetVServerGroupAttributeResponse struct {
	*responses.BaseResponse
	RequestId        string                                   `json:"RequestId" xml:"RequestId"`
	VServerGroupId   string                                   `json:"VServerGroupId" xml:"VServerGroupId"`
	VServerGroupName string                                   `json:"VServerGroupName" xml:"VServerGroupName"`
	BackendServers   BackendServersInSetVServerGroupAttribute `json:"BackendServers" xml:"BackendServers"`
}

// CreateSetVServerGroupAttributeRequest creates a request to invoke SetVServerGroupAttribute API
func CreateSetVServerGroupAttributeRequest() (request *SetVServerGroupAttributeRequest) {
	request = &SetVServerGroupAttributeRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Slb", "2014-05-15", "SetVServerGroupAttribute", "slb", "openAPI")
	return
}

// CreateSetVServerGroupAttributeResponse creates a response to parse from SetVServerGroupAttribute response
func CreateSetVServerGroupAttributeResponse() (response *SetVServerGroupAttributeResponse) {
	response = &SetVServerGroupAttributeResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
